# MSWord Document Product for Zope - MSWord.py
# Copyright (C) 2001 ric BARROCA <eric@barroca.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# MSWord.py : Python module providing an interface to convert
#			  MSWord documents into HTML documents using vwWare (formerly
#			  called mswordview).
#
# Variables :
#	- data (string) : contains the MSWord Document (usualy got from a 
#					  "data = file.read()")
#	- name (string) : the document's filename

import re, os, tempfile

class MSWordDoc:

	def __init__(self, name, data):
		"Initialization : create tmp work directory and copy the document into a file."
		self.prefix = "/usr/local" # The path prefix where wvWare ist installed (usualy /usr or /usr/local)
		self.tmpdir = tempfile.mktemp()
		self.name = name
		self.data = data
		os.mkdir('%s' % self.tmpdir)
		filedest = open("%s/%s.doc" % (self.tmpdir, self.name), "w")
		filedest.write(self.data)
		filedest.close()
	
	def Convert(self):
		"Convert the document"
		print self.name
		#os.system('cd %s/%s && wvHtml %s.doc %s.html &> /dev/null' % (self.tmpdir, self.name, self.name, self.name))
		#os.system('cd %s/%s && /usr/local/bin/wvHtml %s.doc %s.html' % (self.tmpdir, self.name, self.name, self.name))
		os.system('cd "%s" && %s/bin/wvWare -x %s/lib/wv/wvZope.xml "%s.doc" > "%s.html"' % (self.tmpdir, self.prefix, self.prefix, self.name, self.name))

	def cleandir(self):
		for i in os.listdir("%s" % self.tmpdir):
			os.remove("%s/%s" % (self.tmpdir, i))
		os.rmdir("%s" % self.tmpdir)
	
	def getDocHTML(self):
		html = open("%s/%s.html" % (self.tmpdir, self.name)).read()
		return html

	def getImgs(self):
		imgs = {}
		for i in os.listdir("%s" % self.tmpdir):
			result = re.match("^.+\.(?P<ext>.+)$", i)
			if result is not None:
				ext = result.group('ext') 
				if ext in ("png", "jpg", "gif"):
					imgs[i] = open("%s/%s" % (self.tmpdir, i)).read()
		return imgs
